unit u_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, Buttons;

type

  obj_parm=^Segment;
   Segment= Record
    n: String;
    l,w,t,h: Word;
    next: obj_parm;
   end;
  { Tf_main }

  Tf_main = class(TForm)
    btn_save: TButton;
    btn_s1: TButton;
    btn_s2: TButton;
    btn_s3: TButton;
    lb_size: TLabel;
    lb_sc_x: TLabel;
    lb_sc_y: TLabel;
    btn_tst: TSpeedButton;

    procedure btn_s1Click(Sender: TObject);
    procedure btn_saveClick(Sender: TObject);
    procedure btn_s2Click(Sender: TObject);
    procedure btn_s3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

  private
   old:TPoint;
   o_scalex,o_scaley:double;
   first,last:obj_parm;
   first_obj:Boolean;
  procedure input_new(new_obj: obj_parm);
  procedure ScaleIt;

    { private declarations }
  public
    { public declarations }
  end;



var
  f_main: Tf_main;

implementation

{ Tf_main }

procedure Tf_main.ScaleIt;
var st,sh,sl,sw,i:integer;
    scalex,scaley:double;
    rnr:obj_parm;
begin
 scalex:= f_main.Width/old.X;
 scaley:= f_main.Height/old.y;
 If (o_scalex<>scalex) or (o_scaley<>scaley) then begin
  lb_size.Caption:='Size = '+IntToStr(f_main.Width)+'x'+IntToStr(f_main.Height);
  lb_sc_x.Caption:='Scale X = '+FormatFloat('0.0000',scalex);
  lb_sc_y.Caption:='Scale y = '+FormatFloat('0.0000',scaley);
  rnr:=first;
  if (ComponentCount>0) and (first_obj=false) then begin
   for i:= 0 to ComponentCount-1 do begin
    if (Components[i] is TControl) then begin
     sl:=round (rnr^.l*scalex);
     sw:=round (rnr^.w*scalex);
     st:=round (rnr^.t*scaley);
     sh:=round (rnr^.h*scaley);
     TControl(Components[i]).SetBounds(sl,st,sw,sh);
     rnr:=rnr^.next;
    end;    
   end;
  end;
  o_scalex:=scalex;
  o_scaley:=scaley;
 end;
end;

procedure Tf_main.FormShow(Sender: TObject);
var i:Integer;
    nw_obj:obj_parm;
begin
  old.X:=f_main.Width;
  old.y:=f_main.Height;
  for i:= 0 to ComponentCount-1 do begin
   if (Components[i] is TControl) then begin
    new (nw_obj);
    nw_obj^.n:=TControl(Components[i]).Name;
    nw_obj^.l:=TControl(Components[i]).BaseBounds.Left;
    nw_obj^.w:=TControl(Components[i]).BaseBounds.Right-TControl(Components[i]).BaseBounds.Left;
    nw_obj^.t:=TControl(Components[i]).BaseBounds.Top;
    nw_obj^.h:=TControl(Components[i]).BaseBounds.Bottom-TControl(Components[i]).BaseBounds.Top;
    input_new (nw_obj);
   end;
  end;
end;

procedure Tf_main.FormResize(Sender: TObject);
begin
 ScaleIt;
end;

procedure Tf_main.input_new (new_obj:obj_parm);
var p: obj_parm;
begin
  if first_obj = true then begin
    first:= new_obj; first^.next:= NIL; last:= first;
  end
  else begin
    p:= last; new_obj^.next:= NIL; p^.next:= new_obj; last:= new_obj;
  end;
  first_obj:= false;
end;

procedure Tf_main.FormClose(Sender: TObject; var CloseAction: TCloseAction);
var runner,tmp: obj_parm;
begin
 if first_obj = false then begin
 runner:= first;
 while runner<> NIL do begin
  tmp:= runner^.next; Dispose(runner); runner:= tmp;
 end;
 first_obj:= true;
 end;
end;

procedure Tf_main.btn_s1Click(Sender: TObject);
begin
 f_main.Width:= 400;
 f_main.Height:= 300;
end;

procedure Tf_main.btn_saveClick(Sender: TObject);
var rnr:obj_parm;
    f:TextFile;
begin
 rnr:=first;
 AssignFile(f,'object-para.txt'); rewrite (f);
 while (rnr<>nil) do begin
  writeln (f,rnr^.n+'@'+IntToStr(rnr^.l)+','+IntToStr(rnr^.t)+'  '+IntToStr(rnr^.w)+'x'+IntToStr(rnr^.h));
  rnr:=rnr^.next;
 end;
 CloseFile(f);
end;

procedure Tf_main.btn_s2Click(Sender: TObject);
begin
 f_main.Width:= 800;
 f_main.Height:= 600;
end;

procedure Tf_main.btn_s3Click(Sender: TObject);
begin
 f_main.Width:= 400;
 f_main.Height:= 600;
end;

procedure Tf_main.FormCreate(Sender: TObject);
begin
 o_scalex:=1;
 o_scaley:=1;
 old.x:=400;
 old.y:=300;
 first_obj:=true;
end;


initialization
  {$I u_main.lrs}
end.

